//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue
#property indicator_width1 2

//
//
//
//
//

extern string TimeFrame               = "Current time frame";
extern int    VZPeriod                =  14;
extern double OverBoughtLevel         =  40;
extern double OverSoldLevel           = -40;
extern bool   Interpolate             = true;
extern bool   alertsOn                = false;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsEmail             = false;

//
//
//
//
//

double vz[];
double trend[];
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,vz);
   SetIndexBuffer(1,trend);
   
      //
      //
      //
      //
      //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      SetLevelValue(0,OverBoughtLevel);
      SetLevelValue(1,OverSoldLevel);
   IndicatorShortName(timeFrameToString(timeFrame)+" volume zone osillator ("+VZPeriod+")");      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _vp 0
#define _tv 1

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { vz[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         double alpha = 2.0 / (1.0 + VZPeriod);
         
      //
      //
      //
      //
      //
               
      for (i=limit,r=Bars-i-1;i>=0;i--,r++)
      {
         double sign = 0; 
            if (Close[i]>Close[i+1]) sign =  1;
            if (Close[i]<Close[i+1]) sign = -1;
         double R = sign * Volume[i];
         if (r==0)
         {
            work[r][_vp] = R;
            work[r][_tv] = Volume[i];
            continue;
         }            
         
         //
         //
         //
         //
         //
         
            work[r][_vp] = work[r-1][_vp]+alpha*(R        -work[r-1][_vp]);
            work[r][_tv] = work[r-1][_tv]+alpha*(Volume[i]-work[r-1][_tv]);
            trend[i]     = trend[i+1];

            if (work[r][_tv]!=0)
                  vz[i] = 100.0*work[r][_vp]/work[r][_tv];
            else  vz[i] = 0;                  

            if (vz[i]>OverBoughtLevel) trend[i] =  1;
            if (vz[i]<OverSoldLevel)   trend[i] = -1;
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         vz[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VZPeriod,OverBoughtLevel,OverSoldLevel,0,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",VZPeriod,OverBoughtLevel,OverSoldLevel,1,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
                    vz[i+k] = vz[i] + (vz[i+n]-vz[i])*k/n;
   }
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));

      //
      //
      //
      //
      //
            
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"over bought level crossed up");
         if (trend[whichBar] == -1) doAlert(whichBar,"over sold level crossed down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static datetime previousTime  = 0;
   static string   previousAlert = "";
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(timeFrame)+" Donchian channel ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Donchian channel"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}